#include "struct.h"


/* -------------------------------------------------------------------- */
/* creerTete permet de créer la tête de la liste                        */
/*                                                                      */
/* En entrée: Aucune entrée                                             */
/*                                                                      */
/* En sortie: ptrTete, le pointeur de la tête de la liste               */
/* -------------------------------------------------------------------- */

semaine_t *creerTete() {
  semaine_t *ptrTete = malloc(sizeof(semaine_t));
  strcpy(ptrTete->annee, "\0");
  strcpy(ptrTete->semaine, "53");
  ptrTete->act = NULL;
  ptrTete->suiv = NULL;

  return ptrTete;
}

/* -------------------------------------------------------------------- */
/* creerListChainee, permet de créer les listes chainnées               */
/*                                                                      */
/* En entrée:    ptrSemaineTete, pointeur de la tête de la liste        */
/*               taille, nombre de ligne du tableau tab                 */
/*               tab, tableau des lignes de l'agenda traitée (mise en   */
/*               page + tri)                                            */
/*                                                                      */
/* En sortie: Aucune sortie                                             */
/* -------------------------------------------------------------------- */

void creerListeChainee(semaine_t *ptrSemaineTete, char tab[][5][TAILLE_MAX],
                       int taille) {

  int compteur;
  for (compteur = 0; compteur < taille; compteur++) {
    semaine_t *ptrSemaineCour = ptrSemaineTete;
    while (ptrSemaineCour->suiv != NULL) {
      ptrSemaineCour = ptrSemaineCour->suiv;
    }

    if ((atoi(ptrSemaineCour->annee) == atoi(tab[compteur][0])) &&
        (atoi(ptrSemaineCour->semaine) == atoi(tab[compteur][1]))) {

      action_t *ptrNouvelleAction = malloc(sizeof(action_t));
      strcpy(ptrNouvelleAction->jour, tab[compteur][2]);
      strcpy(ptrNouvelleAction->heure, tab[compteur][3]);
      strcpy(ptrNouvelleAction->nom, tab[compteur][4]);
      ptrNouvelleAction->suiv = NULL;
      // remplirNouvelleAction(ptrNouvelleAction, tab[compteur]);
      action_t *ptrActionCour = ptrSemaineCour->act;
      if (ptrActionCour == NULL) {
        ptrSemaineCour->act = ptrNouvelleAction;
        // creerNouvelleAction(ptrSemaineCour->act, tab[compteur]);
      } else {
        while (ptrActionCour->suiv != NULL) {
          ptrActionCour = ptrActionCour->suiv;
        }

        ptrActionCour->suiv = ptrNouvelleAction;
        // creerNouvelleAction(ptrActionCour->suiv, tab[compteur]);
      }
    } else {
      // creerNouvelleSemaine(ptrSemaineCour->suiv,tab[compteur]);
      // printf("%s\n",ptrSemaineCour->suiv->annee);
      // creerNouvelleAction(ptrSemaineCour->suiv->act,tab[compteur]);

      semaine_t *ptrNouvelleSemaine = malloc(sizeof(semaine_t));
      strcpy(ptrNouvelleSemaine->annee, tab[compteur][0]);
      strcpy(ptrNouvelleSemaine->semaine, tab[compteur][1]);
      ptrNouvelleSemaine->act = malloc(sizeof(action_t));
      // ptrNouvelleSemaine->act = NULL;
      ptrNouvelleSemaine->suiv = NULL;
      // creerNouvelleAction(ptrNouvelleSemaine->act,tab[compteur]);
      strcpy(ptrNouvelleSemaine->act->jour, tab[compteur][2]);
      strcpy(ptrNouvelleSemaine->act->heure, tab[compteur][3]);
      strcpy(ptrNouvelleSemaine->act->nom, tab[compteur][4]);
      ptrNouvelleSemaine->act->suiv = NULL;
      ptrSemaineCour->suiv = ptrNouvelleSemaine;
    }
  }
}

/* -------------------------------------------------------------------- */
/* afficherAgenda, permet d'afficher l'agenda dans le terminal          */
/*                                                                      */
/* En entrée:    ptrSemaineTete, pointeur de la tête de la liste        */
/*               taille                                                 */
/*                                                                      */
/* En sortie: Aucune sortie, uniquement affichage de l'agenda           */
/* -------------------------------------------------------------------- */

void afficherAgenda(struct semaine *ptrTeteReelle) {
  action_t *ptrAction;
  semaine_t *ptrSemCour = ptrTeteReelle->suiv;
  if (ptrSemCour == NULL) {
    printf("agenda vide\n");
  } else {
    while (ptrSemCour != NULL) {
      printf("annee : %s  semaine : %s\n", ptrSemCour->annee,
             ptrSemCour->semaine);
      ptrAction = ptrSemCour->act;
      while (ptrAction != NULL) {
        printf("            jour : %s   heure : %s     nom : %s\n",
               ptrAction->jour, ptrAction->heure, ptrAction->nom);
        ptrAction = ptrAction->suiv;
      }
      ptrSemCour = ptrSemCour->suiv;
    }
  }
}

/* -------------------------------------------------------------------- */
/* tailleFichier, permet de connaitre le nombre de ligen d'un fichier   */
/*                                                                      */
/* En entrée:    le nom du fichier dont il faut compter les lignes      */
/*                                                                      */
/* En sortie: le nombre de lignes du fichier                            */
/* -------------------------------------------------------------------- */

int tailleFichier(char nomFichier[TAILLE_MAX]) {

  FILE * fichier = NULL;
  char chaine[TAILLE_MAX];
  fichier = fopen(nomFichier, "r");

  int compteur = 0;

  if (fichier != NULL) {
    while (fgets(chaine, TAILLE_MAX, fichier) != NULL) {
      compteur++;
    }
    fclose(fichier);
  }
  return compteur;
}

/* -------------------------------------------------------------------- */
/* creerTab, permet de créer le tableau contenant les lignes du fichier */
/*                                                                      */
/* En entrée:   tabPhrase,                                              */
/*              nomFichier                                              */
/*                                                                      */
/* En sortie: Aucune sortie                                             */
/* -------------------------------------------------------------------- */

void creerTab(char tabPhrases[][TAILLE_MAX], char *nomFichier) {
  FILE *fichier = NULL;
  fichier = fopen(nomFichier, "r");
  int compteur = 0;

  if (fichier != NULL) {
    while (fgets(tabPhrases[compteur], TAILLE_MAX, fichier) != NULL) {
      compteur++;
    }
    fclose(fichier);
  }
}

/* -------------------------------------------------------------------- */
/* triFusion, effectue un tri fusion sur un tableau                     */
/*                                                                      */
/* En entrée:   i j,                                                    */
/*              tabPhrase                                               */
/*              tmp                                                     */
/*                                                                      */
/* En sortie: Aucune sortie                                             */
/* -------------------------------------------------------------------- */

void triFusion(int i, int j, char tabPhrases[][TAILLE_MAX],
               char tmp[][TAILLE_MAX]) {

  if (j <= i) {
    return;
  }

  int m = (i + j) / 2;

  triFusion(i, m, tabPhrases, tmp); // trier la moitié gauche récursivement
  triFusion(m + 1, j, tabPhrases, tmp); // trier la moitié droite récursivement

  int pg = i;     // pg pointe au début du sous-tableau de gauche
  int pd = m + 1; // pd pointe au début du sous-tableau de droite
  int c;          // compteur

  // on boucle de i à j pour remplir chaque élément du tableau final fusionné
  for (c = i; c <= j; c++) {
    if (pg ==
        m + 1) { // le pointeur du sous-tableau de gauche a atteint la limite
      strcpy(tmp[c], tabPhrases[pd]);
      pd++;
    } else if (pd == j + 1) { // le pointeur du sous-tableau de droite a atteint
                              // la limite
      strcpy(tmp[c], tabPhrases[pg]);
      pg++;
    } else if (atoi(tabPhrases[pg]) <
               atoi(tabPhrases[pd])) { // le pointeur du sous-tableau de gauche
                                       // pointe vers un élément plus petit
      strcpy(tmp[c], tabPhrases[pg]);
      pg++;
    } else { // le pointeur du sous-tableau de droite pointe vers un élément
             // plus petit
      strcpy(tmp[c], tabPhrases[pd]);
      pd++;
    }
  }

  for (c = i; c <= j; c++) { // copier les éléments de tmp[] à tab[]
    strcpy(tabPhrases[c], tmp[c]);
  }
}

/* -------------------------------------------------------------------- */
/* fctContientMotif, permet de                                          */
/*                                                                      */
/* En entrée:   chaine,                                                 */
/*              motif                                                   */
/*                                                                      */
/* En sortie: Aucune sortie                                             */
/* -------------------------------------------------------------------- */

int fctContientMotif(char *chaine, char *motif) {

  int OK = 0;
  int compteurChaine = 0;
  int compteurMotif = 0;

  //printf("%s\n", motif);
  if (*motif == '\0') {
    OK = 1;
  } else {

    while ((OK == 0) && (*(chaine + compteurChaine) != '\0')) {
      if (*(chaine + compteurChaine) == *motif) {

        compteurMotif = 0;
        while ((*(chaine + compteurChaine + compteurMotif) ==
                *(motif + compteurMotif)) &&
               (*(chaine + compteurChaine + compteurMotif) != '\0') &&
               (OK == 0)) {
          compteurMotif++;
          if (*(motif + compteurMotif) == '\0') {
            OK = 1;
          }
        }
      }
      compteurChaine++;
    }
  }

  return OK;
}

// listeC_t * listeC;

// void remplirStructureListeC(semaine_t * ptrTeteReelle,listeC_t * listeC, int
// taille, char motif[TAILLE_MAX]){
//   // listeC->debut=malloc(sizeof(char *));
//   // listeC->fin=malloc(sizeof(char *));
//   char listeContigue[taille][TAILLE_MAX];
//   strcpy(listeContigue[0],"pas de motif");
//   char temp[TAILLE_MAX];

//   //printf("%s\n",  listeC->fin);
//   semaine_t * ptrSemCour=ptrTeteReelle;
//   action_t * ptrActCour;
//   int compteurListeC=0;

//   int tailleMotif=0;
//   while(motif[tailleMotif] != '\0'){
//     tailleMotif++;
//   }
//   printf("%d\n",tailleMotif);
//   if(tailleMotif<=10){
//     while(ptrSemCour != NULL){
//       ptrActCour=ptrSemCour->act;
//       while(ptrActCour != NULL){
//         if(fctContientMotif(ptrActCour->nom, motif) == 1){
//        // printf("phrase : %s  motif : %s   contient : \n",ptrActCour->nom,
//        motif);
//        //  printf("1\n");

//           strcpy(temp,ptrSemCour->annee);
//           strcat(temp,ptrSemCour->semaine);
//           strcat(temp,ptrActCour->jour);
//           if(compteurListeC == 0){
//             strcpy(listeContigue[compteurListeC],temp);
//             compteurListeC++;
//           }else{
//             if(strcmp(temp,listeContigue[compteurListeC-1]) != 0){
//               strcpy(listeContigue[compteurListeC],temp);
//               compteurListeC++;
//             }
//           }

//           }
//         ptrActCour=ptrActCour->suiv;
//       }
//       ptrSemCour=ptrSemCour->suiv;
//     }
//   }
//   //if(strcmp(listeContigue[0],"pas de motif") != 0){

//   listeC->debut =  listeContigue[0];
//   listeC->fin = listeContigue[compteurListeC -1];// + compteurListeC - 1);
//   for(int i=0;i<compteurListeC;i++){
//     printf("%s\n", listeContigue[i]);
//   }
//   //   printf("%s\n",listeContigue[compteurListeC-1]);
//   // printf("%s\n",listeC->fin);
// //}
// }

/* -------------------------------------------------------------------- */
/* remplirStructureListeC_AvecFicTxt, permet de                         */
/*                                                                      */
/* En entrée:   listeC                                                  */
/*              nomFichier                                              */
/*              motif                                                   */
/*              taille                                                  */
/*                                                                      */
/* En sortie: Aucune sortie                                             */
/* -------------------------------------------------------------------- */

void remplirStructureListeC_AvecFicTxt(listeC_t *listeC, char *nomFichier,
                                       char *motif, char listeContigue[][TAILLE_MAX]) {

  FILE *fichier = NULL;
  char chaine[TAILLE_MAX];
  fichier = fopen(nomFichier, "r");
  //char  listeContigue[taille][TAILLE_MAX];
  // strcpy(* listeContigue,"pas de motif");

  int compteurListeC = 0;

  if (fichier != NULL) {
    strcpy(chaine,"\0");
    while (fgets(chaine, TAILLE_MAX, fichier) != NULL) {
      if (fctContientMotif(chaine + 9, motif) == 1) {
        //printf("%s\n",chaine+9);
        if (compteurListeC == 0) {
          strcpy(listeContigue[compteurListeC], chaine);
          compteurListeC++;
        } else {
          if (strcmp(chaine, listeContigue[compteurListeC - 1]) != 0) {
            strcpy(listeContigue[compteurListeC], chaine);
            compteurListeC++;
          }
        }
      }
      strcpy(chaine,"\0");
      }
    fclose(fichier);
    }
  //printf("%d\n", compteurListeC);
  listeC->debut = * listeContigue;
      listeC->fin = * (listeContigue + compteurListeC-1); // + compteurListeC - 1);
  printf("%s\n",listeC->fin);
      for (int i = 0; i < compteurListeC; i++) {
        printf("%d    %s\n",i, listeContigue[i]);
       // printf("1\n");
      }}




  
      // compteur++;

      // int tailleMotif = 0;
      // while (motif[tailleMotif] != '\0') {
      //   tailleMotif++;
      // }
      // printf("%d\n", tailleMotif);
      // if (tailleMotif <= 10) {

      //   if (fctContientMotif(chaine + 9, motif, tailleMotif) == 1) {
      //     // printf("phrase : %s  motif : %s   contient : \n",ptrActCour->nom,
      //     // motif);
      //     //  printf("1\n");

      //     strcpy(temp, ptrSemCour->annee);
      //     strcat(temp, ptrSemCour->semaine);
      //     strcat(temp, ptrActCour->jour);
      //     if (compteurListeC == 0) {
      //       strcpy(listeContigue[compteurListeC], temp);
      //       compteurListeC++;
      //     } else {
      //       if (strcmp(temp, listeContigue[compteurListeC - 1]) != 0) {
      //         strcpy(listeContigue[compteurListeC], temp);
      //         compteurListeC++;
      //       }
      //     }
      //   }
      //   fclose(fichier);
      // }
      // // listeC->debut=malloc(sizeof(char *));
      // // listeC->fin=malloc(sizeof(char *));
      // char listeContigue[taille][TAILLE_MAX];
      // strcpy(listeContigue[0], "pas de motif");
      // char temp[TAILLE_MAX];

      // // printf("%s\n",  listeC->fin);
      // semaine_t *ptrSemCour = ptrTeteReelle;
      // action_t *ptrActCour;
      // int compteurListeC = 0;

      // int tailleMotif = 0;
      // while (motif[tailleMotif] != '\0') {
      //   tailleMotif++;
      // }
      // printf("%d\n", tailleMotif);
      // if (tailleMotif <= 10) {
      //   while (ptrSemCour != NULL) {
      //     ptrActCour = ptrSemCour->act;
      //     while (ptrActCour != NULL) {
      //       if (fctContientMotif(ptrActCour->nom, motif, tailleMotif) == 1) {
      //         // printf("phrase : %s  motif : %s   contient :
      //         // \n",ptrActCour->nom, motif);
      //         //  printf("1\n");

      //         strcpy(temp, ptrSemCour->annee);
      //         strcat(temp, ptrSemCour->semaine);
      //         strcat(temp, ptrActCour->jour);
      //         if (compteurListeC == 0) {
      //           strcpy(listeContigue[compteurListeC], temp);
      //           compteurListeC++;
      //         } else {
      //           if (strcmp(temp, listeContigue[compteurListeC - 1]) != 0) {
      //             strcpy(listeContigue[compteurListeC], temp);
      //             compteurListeC++;
      //           }
      //         }
      //       }
      //       ptrActCour = ptrActCour->suiv;
      //     }
      //     ptrSemCour = ptrSemCour->suiv;
      //   }
      // }
      // // if(strcmp(listeContigue[0],"pas de motif") != 0){

      // listeC->debut = listeContigue[0];
      // listeC->fin = listeContigue[compteurListeC - 1]; // + compteurListeC - 1);
      // for (int i = 0; i < compteurListeC; i++) {
      //   printf("%s\n", listeContigue[i]);
      // }
      // //   printf("%s\n",listeContigue[compteurListeC-1]);
      // // printf("%s\n",listeC->fin);
      // //}
    

    void SDDintoFILE(semaine_t * ptrTeteReelle) {

      FILE *fichier2 = NULL;
      char chaine[TAILLE_MAX];
      fichier2 = fopen("resultatCommande.txt", "w");
      // fprintf(fichier2,"HELLO\n");
      int init = 0;

      semaine_t *ptrSemCour = ptrTeteReelle;
      action_t *ptrActCour;

      while (ptrSemCour != NULL) {
        ptrActCour = ptrSemCour->act;
        while (ptrActCour != NULL) {
          strcpy(chaine, ptrSemCour->annee);
          strcat(chaine, ptrSemCour->semaine);
          strcat(chaine, ptrActCour->jour);
          strcat(chaine, ptrActCour->heure);
          strcat(chaine, ptrActCour->nom);
          if (init == 0) {
            fprintf(fichier2, "%s", chaine);
            init = 1;
          } else {
            fprintf(fichier2, "\n%s", chaine);
          }

          ptrActCour = ptrActCour->suiv;
        }
        ptrSemCour = ptrSemCour->suiv;
      }
      fclose(fichier2);
    }

    // int suppression(semaine_t * ptrTeteReelle, char toutSaufNom[TAILLE_MAX]) {

    //   semaine_t *ptrSemPrec = ptrTeteReelle;
    //   semaine_t *ptrSemCour = ptrSemPrec->suiv;
    //   action_t *ptrActPrec;
    //   action_t *ptrActCour;
    //   int efface = 0;

    //   while (ptrSemCour != NULL && efface == 0) {
    //     int prec = 0;
    //     ptrActCour = ptrSemCour->act;
    //     while (ptrActCour != NULL && efface == 0) {
    //       char chaine[TAILLE_MAX];

    //       strcpy(chaine, ptrSemCour->annee);
    //       strcat(chaine, ptrSemCour->semaine);
    //       strcat(chaine, ptrActCour->jour);
    //       strcat(chaine, ptrActCour->heure);

    //       if (strcmp(chaine, toutSaufNom) == 0) {
    //         if (prec == 0 && ptrActCour->suiv == NULL) {
    //           ptrSemPrec->suiv = ptrSemCour->suiv;
    //           free(ptrSemCour);
    //           free(ptrActCour);
    //           efface = 1;
    //         } else {
    //           if (prec == 0) {
    //             ptrSemCour->act = ptrActCour->suiv;
    //           } else {
    //             ptrActPrec->suiv = ptrActCour->suiv;
    //           }
    //           free(ptrActCour);
    //           efface = 1;
    //         }
    //       } else {
    //         if (prec == 0) {
    //           ptrActPrec = ptrSemCour->act;
    //           ptrActCour = ptrActPrec->suiv;
    //           prec = 1;
    //         } else {
    //           ptrActPrec = ptrActPrec->suiv;
    //           ptrActCour = ptrActPrec->suiv;
    //         }
    //       }
    //     }
    //     if (efface != 1) {
    //       ptrSemPrec = ptrSemPrec->suiv;
    //       ptrSemCour = ptrSemPrec->suiv;
    //     }
    //   }
    //   return efface;
    // }

void suppression2(char nomFichier[TAILLE_MAX], char nomFichierTemp[TAILLE_MAX], char motif[TAILLE_MAX], char annee[5], char semaine[3], char jour[2], char heure[3], int mode) {

  FILE * fichier=NULL;
  fichier=fopen(nomFichier,"r");

  FILE * temp=NULL;
  temp=fopen(nomFichierTemp,"w");

  char chaine[TAILLE_MAX];
  char chaineTemp[TAILLE_MAX];

  if(fichier != NULL){
    while(fgets(chaine,TAILLE_MAX,fichier) != NULL){
      int OK=1;
      
      if(fctContientMotif(chaine+9,motif) == mode){
        if(motif[0] != '\0'){
          OK=0;
        }
      }
      
      strcpy(chaineTemp,chaine);
      chaineTemp[4]='\0';
      if(fctContientMotif(chaineTemp,annee) == mode){
        if(annee[0] != '\0'){
          OK=0;
        }
      }

      strcpy(chaineTemp,chaine);
      chaineTemp[6]='\0';
      if(fctContientMotif(chaineTemp+4,semaine) == mode){
        if(semaine[0] != '\0'){
          OK=0;
        }
      }

      strcpy(chaineTemp,chaine);
      chaineTemp[7]='\0';
      if(fctContientMotif(chaineTemp+6,jour) == mode){
        if(jour[0] != '\0'){
          OK=0;
        }
      }

      strcpy(chaineTemp,chaine);
      chaineTemp[9]='\0';
      if(fctContientMotif(chaineTemp+7,heure) == mode){
        if(heure[0] != '\0'){
          OK=0;
        }
      }
      
      if(OK == 1){
        fprintf(temp, "%s", chaine);
        }
      
      
      
    }
    fclose(fichier);
  }
  fclose(temp);
  }

void remplirTab(char tabPhrasesTriees[][TAILLE_MAX], char tab[][5][TAILLE_MAX],int taille){

  int compteur=0;
  for(int u=0; u<taille;u++){
  //while(strcmp(tabPhrasesTriees[compteur],"\0") != 0){
  tab[compteur][0][4]='\0';
  tab[compteur][1][2]='\0';
  tab[compteur][2][1]='\0';
  tab[compteur][3][2]='\0';
  tab[compteur][4][10]='\0';

  for(int i=0;i<4;i++){
    tab[compteur][0][i]=tabPhrasesTriees[compteur][i];
  }
  for(int i=0;i<2;i++){
    tab[compteur][1][i]=tabPhrasesTriees[compteur][4+i];
  }
  tab[compteur][2][0]=tabPhrasesTriees[compteur][6];
  for(int i=0;i<2;i++){
    tab[compteur][3][i]=tabPhrasesTriees[compteur][7+i];
  }
  for(int i=0;i<10;i++){
    tab[compteur][4][i]=tabPhrasesTriees[compteur][9+i];
  }
  compteur++;
} 
}

/* -------------------------------------------------------------------- */
/* freeall permet de libérer les allocations mémoire                    */
/*                                                                      */
/* En entrée: ptrTeteRelle, pointeur de la tête du 1er niveau de la     */
/* liste chainée                                                        */
/*                                                                      */
/* En sortie: Aucune sortie                                             */
/* -------------------------------------------------------------------- */

void freeAll(semaine_t * ptrTeteReelle)
{
  semaine_t *ptrSemPrecFree = ptrTeteReelle;
  semaine_t *ptrSemCourFree = ptrTeteReelle->suiv;

  while (ptrSemCourFree != NULL) {

    action_t *ptrActionPrecFree = ptrSemCourFree->act;
    action_t *ptrActionCourFree = ptrActionPrecFree->suiv;

    while (ptrActionCourFree != NULL) {
      free(ptrActionPrecFree);
      ptrActionPrecFree = ptrActionCourFree;
      ptrActionCourFree = ptrActionCourFree->suiv;
    }
    free(ptrActionPrecFree);
    free(ptrSemPrecFree);
    ptrSemPrecFree = ptrSemCourFree;
    ptrSemCourFree = ptrSemCourFree->suiv;
  }
  free(ptrSemPrecFree);
  
}


  void creerSDDafficherAgendaPrintRecap(char nomFichier[TAILLE_MAX]){
    
    int taille = tailleFichier(nomFichier);
    char tabPhrases[taille][TAILLE_MAX];
    char tmp[taille][TAILLE_MAX];
char tab[taille][5][TAILLE_MAX];
    semaine_t *ptrSemaineTete = NULL;
    
    ptrSemaineTete = creerTete();

    creerTab(tabPhrases, nomFichier);
    triFusion(0, taille - 1, tabPhrases, tmp);
    remplirTab(tabPhrases, tab, taille);
    creerListeChainee(ptrSemaineTete, tab, taille);
    afficherAgenda(ptrSemaineTete);
    SDDintoFILE(ptrSemaineTete);
    freeAll(ptrSemaineTete);
    }



